# Copyright (C) 2012 Martin Albisetti - argentina@gmail.com

from django.db import models
from django.contrib.auth.models import User


class Team(models.Model):
    """"""
    name = models.CharField(max_length=100)

    def __unicode__(self):
        return self.name


class Task(models.Model):
    """"""
    title = models.CharField(max_length=1000)
    description = models.TextField(null=True)
    owner = models.ForeignKey(Team)
    when_created = models.DateField(auto_now=True)
    position = models.IntegerField(blank=True, null=True)
    size_days = models.IntegerField()
    assigned_to = models.ManyToManyField(User, related_name='assigned_to',
        blank=True, null=True)

    def __unicode__(self):
        return self.title
