YUI().use('dd-constrain', 'dd-proxy', 'dd-drop', 'io-base', function(Y) {
    //Listen for all drop:over events
    Y.DD.DDM.on('drop:over', function(e) {
        //Get a reference to our drag and drop nodes
        var drag = e.drag.get('node'),
            drop = e.drop.get('node');

        //Are we dropping on a li node?
        if (drop.get('tagName').toLowerCase() === 'td') {
            //Are we not going right?
            if (!goingUp) {
                drop = drop.get('nextSibling');
            }
            //Add the node to this list
            e.drop.get('node').get('parentNode').insertBefore(drag, drop);
            //Resize this nodes shim, so we can drop on it later.
            e.drop.sizeShim();
        }
    });
    //Listen for all drag:drag events
    Y.DD.DDM.on('drag:drag', function(e) {
        //Get the last x point
        var x = e.target.lastXY[0];
        //is it greater than the lastX var?
        if (x < lastX) {
            //We are going left
            goingUp = true;
        } else {
            //We are going right.
            goingUp = false;
        }
        //Cache for next check
        lastX = x;
    });
    //Listen for all drag:start events
    Y.DD.DDM.on('drag:start', function(e) {
        //Get our drag object
        var drag = e.target;
        //Set some styles here
        drag.get('node').setStyle('opacity', '.25');
        drag.get('dragNode').set('innerHTML', drag.get('node').get('innerHTML'));
        drag.get('dragNode').setStyles({
            opacity: '.5',
            borderColor: drag.get('node').getStyle('borderColor'),
            backgroundColor: drag.get('node').getStyle('backgroundColor')
        });
    });
    //Listen for a drag:end events
    Y.DD.DDM.on('drag:end', function(e) {
        var drag = e.target;
        //Put our styles back
        drag.get('node').setStyles({
            visibility: '',
            opacity: '1'
        });
        var row_tds = drag.get('node').get('parentNode').all('td');
        // Reset all the positions
        counter = 1;
        row_tds.each(function(node) {
            node.setAttribute('data-pos', counter);
            counter++;
        });
        Y.io('/move-task/?task_id='+
        drag.get('node').getAttribute('data-id') +'&new_pos=' +
        drag.get('node').getAttribute('data-pos'))
    });
    //Listen for all drag:drophit events
    Y.DD.DDM.on('drag:drophit', function(e) {
        var drop = e.drop.get('node'),
            drag = e.drag.get('node');

        //if we are not on an td, we must have been dropped on a tr
        if (drop.get('tagName').toLowerCase() !== 'td') {
            if (!drop.contains(drag)) {
                drop.appendChild(drag);
            }
        }
    });

    //Static Vars
    var goingUp = false, lastX = 0;

    //Get the list of tds in the lists and make them draggable
    var tds = Y.Node.all('.task');
    tds.each(function(v, k) {
        var dd = new Y.DD.Drag({
            node: v,
            target: {
                padding: '0 0 0 20'
            }
        }).plug(Y.Plugin.DDProxy, {
            moveOnEnd: false
        }).plug(Y.Plugin.DDConstrained, {
            constrain2node: v.get('parentNode')
        });
    });

    //Create simple targets for the 2 lists.
    var team = Y.Node.all('.team');
    team.each(function(v, k) {
        var tar = new Y.DD.Drop({
            node: v
        });
    });

});
